'Tutorial02: A slope
''''''''''''''''''''
'By David 'OddBall' Williamson
''''''''''''''''''''''''''''''
'18th May 2007
''''''''''''''
'Description
''''''''''''
'How to create scenery using the TZone collision zone object.
'
'This tutorial assumes you have read all previous tutorials in the series
'and as such only parts where code has changed will be commented.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

Framework BRL.GLMax2D
Import "PhysLite/PhysLite.bmx"

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics 800,600,,60

PhysicsBegin 800,600,0.1

Global mass:TMass[4]

mass[0]=TMass.Create(390,290,10,20,1)
mass[1]=TMass.Create(410,290,10,20,1,mass[0].GetColGroup())
mass[2]=TMass.Create(390,310,10,20,1,mass[0].GetColGroup())
mass[3]=TMass.Create(410,310,10,20,1,mass[0].GetColGroup())

Global con:TConstraint[6]

con[0]=TConstraint.Create(mass[0],mass[1])
con[1]=TConstraint.Create(mass[0],mass[2])
con[2]=TConstraint.Create(mass[0],mass[3])
con[3]=TConstraint.Create(mass[1],mass[2])
con[4]=TConstraint.Create(mass[1],mass[3])
con[5]=TConstraint.Create(mass[2],mass[3])

Global body:TBody=New TBody
For Local count:Int=0 To 5
	con[count].Assign body
Next

'There's no change to the box creation so we'll jump straight in with the TZone
'Now a TZone defines an area of the simulation that TMass objects can interact with.
'We define this area by making an array x,y coordinate pairs similar to the ones
'used by the Max2Ds DrawPoly function.
Global area:Float[]=[450.0,450.0,500.0,500.0,400.0,600.0,350.0,550.0]
'Now we make the TZone. Notice the second parameter.
'This tells PhysLite that the TZone will be solid and not hollow.
Global zone:TZone=TZone.Create(area,TZone.FILL)

'And it's as easy as that. Now let's see it in action.

Repeat
	
	PhysicsUpdate
	
	Cls
	SetColor 0,0,255
	For Local m:TMass=EachIn mass
		m.Draw
	Next
	SetColor 255,255,255
	For Local c:TConstraint=EachIn con
		c.Draw
	Next
	SetColor 255,0,0
	'Collision zones also have a Draw method.
	zone.Draw
	
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End
'The end
