'Tutorial14: The Clone Wars.
''''''''''''''''''''''''''''
'By David 'OddBall' Williamson
''''''''''''''''''''''''''''''
'26th June 2007
'''''''''''''''
'Description
''''''''''''
'This tutorial covers using a TAdvBody as a template so that creating lots
'of copies is a breeze.
'
'This tutorial assumes you have read all previous tutorials in the series
'and as such only parts where code has changed will be commented.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

Framework BRL.GLMax2D
Import BRL.Random
Import "PhysLite/PhysLite.bmx"

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics 800,600,,60

PhysicsBegin 800,600,0.1,,2

'Remember the box from earlier tutorials? Well lets jog
'your memory. First we load our pre-saved box. This box
'is complete and ready to use, but we load it with the
'active flag set to false. This means that although we've
'loaded the box it won't be live in the simulation.
Global template:TAdvBody=TAdvBody.Load("media/box.plb")

'Now let's make lots of copies.
Global boxes:TList=New TList
For Local ycount:Int=150 To 570 Step 70
	For Local xcount:Int=40 To 760 Step 80
		'Making a copy is as simple as calling the Copy
		'method.
		Local box:TAdvBody=template.Copy()
		'As with loading the TAdvBody has the same position,
		'orientation and velocity as the original so we will
		'need to position it where we want it.
		box.Position xcount,ycount
		'Again we need to activate the copied TAdvBody before
		'it will become live.
		box.Activate
		'And finally we place it in a list so that we can
		'reference it for drawing.
		boxes.AddLast box
	Next
Next

Repeat
	
	PhysicsUpdate
	
	SetClsColor 127,127,127
	Cls
	
	For Local box:TAdvBody=EachIn boxes
		box.Draw
	Next
	
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End
'The end
